// You must implement the following UI element
// playEngine.UIElements.$prevButton
// playEngine.UIElements.$nextButton
// playEngine.UIElements.$closeButton
// playEngine.UIElements.$loader

class GalleryPlayEngine {
    /**
     *
     * @param {PureBox} pureBox
     */
    constructor(pureBox) {
        this.pureBox = pureBox;

        var self   = this,
            $      = this.pureBox.$,
            markup = '<div class="pure-gallery-box"> <div class="pure-container"> <div class="pure-imgs-container"> <div class="pure-img"> <img> </div></div><div class="pure-buttons"> <a class="pure-prev"></a> <a class="pure-next"></a> <a class="pure-close icon-close"></a> </div><div class="pure-loader"><div class="pure-loader-inner ball-pulse-sync"><div></div><div></div><div></div></div></div></div></div>',
            $elems = $(markup).appendTo('body');

        this.UIElements = {
            $galleryBox: $elems,
            $container: $elems.find('.pure-container'),
            $imgsContainer: $elems.find('.pure-imgs-container'),
            $imgs: $elems.find('.pure-img'),
            $loader: $elems.find('.pure-loader'),
            $buttonContainer: $elems.find('.pure-buttons'),
            $prevButton: $elems.find('.pure-prev'),
            $nextButton: $elems.find('.pure-next'),
            $closeButton: $elems.find('.pure-close'),
            $img: $elems.find('.pure-img img')
        };

        this.openCloseTl = {
            play: function (is_reverse) {
                var d, done;

                d = $.Deferred();
                done = ()=> {
                    d.resolve();
                };

                if (is_reverse) {
                    // close
                    self.UIElements.$galleryBox.css({opacity: 0});
                    setTimeout(()=> {
                        self.UIElements.$galleryBox.css({visibility: 'hidden'});
                    }, 600);
                } else {
                    // open
                    self.UIElements.$galleryBox.css({visibility: 'visible', opacity: 1});
                }

                setTimeout(()=> {
                    done();
                }, 600);
                
                return d.promise();
            },
            reverse: function () {
                return this.play(true);
            }
        };
    }

    goto(event) {
        var d;
        d = $.Deferred();
        if (event.from === 'Next') {
            console.log();
        }
        if (event.from === 'Prev') {
            console.log();
        }
        this.UIElements.$img.attr('src', event.src);
        event.preloadImg.done(()=> {
            d.resolve();
        });
        return d.promise();
    };

    open(event) {
        this.UIElements.$img[0].src = event.src;

        return this.openCloseTl.play();
    }

    close() {
        return this.openCloseTl.reverse();
    }

    getUIElements() {
        return this.UIElements;
    }
}


/*
 <<<GLOBAL
 window.GalleryPlayEngine = GalleryPlayEngine;
 GLOBAL;
 */


export default GalleryPlayEngine;
